/**
 * SinglePlay Class represents a class that like a user choose a block randomly
 *
 * @author : zahra_fatehi
 * @version : 0
 */

import java.util.ArrayList;
import java.util.Random;

public class SiglePlay {
    private ArrayList<Block> blocks;
    private User user ;

    /**
     * create a list of all blocks
     */
    public SiglePlay( ){
        blocks = new ArrayList<>();
    }

    /**
     * @param user is bot that in this Class we wanna access the features like color
     */
    public void setUer(User user) {
        this.user = user;
    }

    /**
     * @param blocks r all 64 blocks
     */
    public void setBlocks(ArrayList<Block> blocks) {
        this.blocks = blocks;
    }

    /**
     * @param block is a block that we wanna choose
     * @return true if is available to take block else return false
     */
    private boolean isAvailableToTake(Block block){
        if (user.isAvailableBlockToPick(block , blocks ))
            return true;
        else
            return false;
    }


    /**
     * choose a block randomly
     */
    public Block chooseBlockRandomly(){
        while (true) {
            Random random = new Random();
            for (Block b : blocks) {
                if (b.getRow() == random.nextInt(8) && b.getColumn() == random.nextInt(8) && isAvailableToTake(b)) {
                     return b;
                }
            }
        }
    }


    public Block getChosenBlock() {
        return chooseBlockRandomly();
    }
}
